/*
 * LCD Demo Application
 * Copyright (c) 2013-2014 China JiLiang University
 * All Rights Reserved.
 */

/*!
 * @file        LCDDriver.c
 * @version     1.0
 * @author      Kai Zhang
 * @date        2013-07-07
 * @brief       Һʾ
 */
#include <stdbool.h>
#include <stdint.h>
#include "LCDDriver.h"
#include "driverlib/rom.h"
#include "LCD_Matrix.h"
#include <string.h>

// ʱ
#define setSCK GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, GPIO_PIN_6);
#define rstSCK GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, 0);

// ݴ
#define setSDA GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, GPIO_PIN_7);
#define rstSDA GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, 0);

// ͵ƽƬѡ
#define setCS  GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, GPIO_PIN_1);
#define rstCS  GPIOPinWrite(GPIO_PORTB_BASE, GPIO_PIN_1, 0);

// Ĵѡź
#define setCD  GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_1, GPIO_PIN_1);
#define rstCD  GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_1, 0);

// ͵ƽλλɺ󣬻صߵƽҺģ鿪ʼ
#define setRES GPIOPinWrite(GPIO_PORTE_BASE, GPIO_PIN_5, GPIO_PIN_5);
#define rstRES GPIOPinWrite(GPIO_PORTE_BASE, GPIO_PIN_5, 0);

// ʾʱ任
extern char matrixTransfer[8][8] = {0};

/******************************************************************************
 * @brief  еʾ
 * @param
 * @return none
 ******************************************************************************/
void LCD_ScreenClr() {
	unsigned char i, j;
	for (i = 0; i < 9; i++)				//ѭ0~8ҳ
	{
		rstCS;
		LCD_TransferCmd(0xb0 + i);		//ѡҳ
		LCD_TransferCmd(0x10);			//ѡС
		LCD_TransferCmd(0x00);
		for (j = 0; j < 132; j++) {
			LCD_TransferData(0x00, LCD_DRAW_NORMAL);	//0x00ʾ0x00
		}
	}
}

/******************************************************************************
 * @brief  еĶ˿ڳʼ
 * @param
 * @return none
 ******************************************************************************/
void LCD_Enable()
{
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);					//˿ʹ
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);

	GPIOPinTypeGPIOOutput(GPIO_PORTB_BASE, GPIO_PIN_1);				//˿ΪPB1->CS
	GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_6 | GPIO_PIN_7);//PC6->SCK,PC7->SDA
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_1);				//PD1->CD
	GPIOPinTypeGPIOOutput(GPIO_PORTE_BASE, GPIO_PIN_5);				//PE5->RST
}

/******************************************************************************
 * @brief  ϳʱʱ
 * @param
 * @return none
 ******************************************************************************/
void LCD_Delay2(unsigned int i) {
	int j, k;
	for (j = 0; j < i; j++)
		for (k = 0; k < 990; k++)
			;
}

/******************************************************************************
 * @brief  ϶ʱʱ
 * @param
 * @return none
 ******************************************************************************/
void LCD_Delay3(unsigned int i) {
	int j, k;
	for (j = 0; j < i; j++)
		for (k = 0; k < 10; k++)
			;
}

/******************************************************************************
 * @brief  	ʾ8*8ľ
 * @param	b_Invert ǷҪʾ
 * @return  none
 ******************************************************************************/
void LCD_Draw_Byte(bool b_invert) //дһֽ
{
	unsigned char x, y;
	rstCS;
	setCD;

	for (y = 0; y < 8; y++)
	{
		for (x = 0; x < 8; x++)
		{
			rstSCK;
			if(!b_invert)
			{
				if (matrixTransfer[y][x])
					setSDA
				else
					rstSDA
			}else
			{
				if (!matrixTransfer[y][x])
					setSDA
				else
					rstSDA
			}
			setSCK;
		}
	}

	rstCS;
	setSCK;
}

/******************************************************************************
 * @brief  	ʾ8*8ľ
 * @param	data ʾָ
 * @param	type ǷҪʾ
 * @return  none
 ******************************************************************************/
void LCD_TransferData(unsigned char data, bool b_invert) {
	char count;
	rstCS;
	setCD;

	if(b_invert == LCD_DRAW_HIGHLIGHT)
		data = ~data;

	for (count = 0; count < 8; count++)
	{
		rstSCK;
		if (data & 0x80) {
			setSDA
		} else {
			rstSDA
		}
		setSCK;
		data <<= 1;
	}
}

/******************************************************************************
 * @brief  	Һ
 * @param	command ַ
 * @return  none
 ******************************************************************************/
void LCD_TransferCmd(unsigned char command) {
	char count;
	rstCS;
	rstCD;
	for (count = 0; count < 8; count++)
	{
		rstSCK;
		if (command & 0x80) {
			setSDA;
		} else {
			rstSDA;
		}
		LCD_Delay3(2);   //DELAY
		setSCK;
		LCD_Delay3(2);   //DELAY
		command <<= 1;
	}
}

/******************************************************************************
 * @brief  	ʼҺ
 * @param	none
 * @return  none
 ******************************************************************************/
void LCD_Init() {
	rstRES;
	LCD_Delay2(50);                 //delay
	setRES;
	LCD_Delay2(50);                 //delay
	LCD_TransferCmd(0xe2); 			/*λ*/
	LCD_TransferCmd(0x2c); 			/*ѹ1*/
	LCD_TransferCmd(0x2e); 			/*ѹ2*/
	LCD_TransferCmd(0x2f); 			/*ѹ3*/
	LCD_TransferCmd(0x23); 			/*ֵԱȶȣ÷Χ2027*/
	LCD_TransferCmd(0x81);			/*΢Աȶ*/
	LCD_TransferCmd(0x28); 			/*΢Աȶȵֵ÷Χ063*/
	LCD_TransferCmd(0xa2); 			/*1/9 ƫѹȣbias*/
	LCD_TransferCmd(0xc8); 			/*ɨ˳򣺴ϵc0 c8 */
	LCD_TransferCmd(0xa0); 			/*ɨ˳򣺴 a0 a1*/
	LCD_TransferCmd(0xa6); 			/* 0xa6 0xa7*/
	LCD_TransferCmd(0xaf); 			/*ʾ*/

}

/******************************************************************************
 * @brief  	תʾЧ
 * @param	b_Invert Ƿת
 * @return  none
 ******************************************************************************/
void LCD_InvertLight_All(bool b_Invert)
{
	rstRES;
	LCD_Delay2(50);                 //delay
	setRES;
	LCD_Delay2(50);                 //delay
	LCD_TransferCmd(0xe2); 			/*λ*/
	LCD_TransferCmd(0x2c); 			/*ѹ1*/
	LCD_TransferCmd(0x2e); 			/*ѹ2*/
	LCD_TransferCmd(0x2f); 			/*ѹ3*/
	LCD_TransferCmd(0x23); 			/*ֵԱȶȣ÷Χ2027*/
	LCD_TransferCmd(0x81);			/*΢Աȶ*/
	LCD_TransferCmd(0x28); 			/*΢Աȶȵֵ÷Χ063*/
	LCD_TransferCmd(0xa2); 			/*1/9 ƫѹȣbias*/
	LCD_TransferCmd(0xc8); 			/*ɨ˳򣺴ϵc0 c8 */
	LCD_TransferCmd(0xa0); 			/*ɨ˳򣺴 a0 a1*/
	if(!b_Invert)
		LCD_TransferCmd(0xa7); 			/* 0xa6 0xa7*/
	else
		LCD_TransferCmd(0xa6); 			/* 0xa6 0xa7*/
	LCD_TransferCmd(0xaf); 			/*ʾ*/

	LCD_ScreenClr();
}

/******************************************************************************
 * @brief  	Һ8*8ģ˳ʱ90ȵתҺʾģʽ
 * @param	p_Char	ģָ
 * @return  none
 ******************************************************************************/
void LCD_MatrixChange(unsigned char * p_Char)
{

	int i, j = 0;
	char matrix[8][8] = {0};
	// ȡ
	for(j = 0; j < 8; ++ j)
	{
		char temp ;
		temp =  * (p_Char + j);
		for(i = 7; i >= 0; --i)
		{
			matrix[j][i] = temp & 0x01;
			temp = temp >> 1;
		}
	}

	memset(matrixTransfer, 0, sizeof(matrixTransfer));

	//ת
	for(j = 0; j < 8; ++ j)
	{
		for(i = 0; i < 8; ++i)
		{
			matrixTransfer[i][7-j] = matrix[j][i];
		}
	}

//	//ݻԭ
//	for(j = 0; j < 8; ++ j)
//	{
//		temp1 = 0;
//		for(i = 0; i < 8 ; ++i)
//		{
//			temp1 = temp1 << 1;
//			temp1 = temp1 | matrix_Change[j][i];
//		}
//		* MatrixChanged = temp1;
//		MatrixChanged ++;
//	}
//
//	MatrixChanged = MatrixChanged - 8;
}

/******************************************************************************
 * @brief  	Һ8*8ģ˳ʱ90ȵתҺʾģʽ
 * @param	c	Ҫʾַֻ
 * @param	raw	ַʾ ȡֵΧ0~3
 * @param	col	ַʾ ȡֵΧ0~119
 * @return  0  ʾ
 *			1 ʾʾɹ
 ******************************************************************************/
unsigned char LCD_Draw_Char(char c, unsigned char raw, unsigned char col, bool b_invert) {

	unsigned char * add = asc + (c - 0x20) * 16;
	unsigned int i;							//
	unsigned char col_0 = col;					// λ
	unsigned char col_1 = col >> 4;  			// λ

	//-----------------------------
	//--------------0ʾ---------------
	if (col > LCD_MAX_COL - 1) {
		return 0;
	}
	if (raw > LCD_MAX_RAW - 1) {
		return 0;
	}

	for (i = 0; i < 2; i++)
	{
		rstCS;
		LCD_TransferCmd(0xb0 + raw * 2 + i);             //áҳ
		LCD_TransferCmd(0x10 + (col_1 & 0x0f));			//áСԼеĸλ
		LCD_TransferCmd(0x00 + (col_0 & 0x0f));			//áСԼеĵλ

		LCD_MatrixChange(add + 8*i);

		LCD_Draw_Byte(b_invert);
	}

	return 1; 								//1ʾִгɹ
}


void DisplayGraphic1()
{
	unsigned char * address; //define pointer
	int i,j;
	address = code_graphic1; //data pointer:point to "graphic[]",one-dimensional array
	for(i=0;i<8;i++)
	{
		rstCS;
		LCD_TransferCmd(0xb0+i); //set page address,
		LCD_TransferCmd(0x10);
		LCD_TransferCmd(0x00);
		for(j=0;j<128;j++)
		{
			LCD_TransferData(*address, LCD_DRAW_NORMAL);
			address++;
		}
	}
}

/******************************************************************************
 * @brief  	Һ8*8ģ˳ʱ90ȵתҺʾģʽ
 * @param	index	Ҫʾĺֵģ
 * @param	raw	ַʾ ,ȡֵΧ0~3
 * @param	col	ַʾ ,ȡֵΧ0~119
 * @return  0  ʾ
 *			1 ʾʾɹ
 ******************************************************************************/
unsigned char LCD_Draw_Chinese(unsigned char index, unsigned char raw,
		unsigned char col, bool b_Invert) {
	unsigned char * chinese = CHINESE_MATRIX + 32 * index;
	unsigned int i, j;					//
	unsigned char col_0 = col;		//еλ
	unsigned char col_1 = col >> 4;  //иλ

	//-----------------------------
	//--------------0ʾ---------------
	if (col > 111) {
		return 0;
	}
	if (raw > 3) {
		return 0;
	}

	for (i = 0; i < 2; i++) {
		rstCS;
		LCD_TransferCmd(0xb0 + raw * 2 + i);                 //áҳ
		LCD_TransferCmd(0x10 + (col_1 & 0x0f));			 //áСԼеĸλ
		LCD_TransferCmd(0x00 + (col_0 & 0x0f));			 //áСԼеĵλ
		for (j = 0; j < 16; j++)
		{
			LCD_TransferData(*chinese, b_Invert);
			chinese++;
		}
	}
	return 1; //1ʾִгɹ
}

